#include "clientmainwindow.h"
#include "ui_clientmainwindow.h"

ClientMainWindow::ClientMainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::ClientMainWindow)
{
    ui->setupUi(this);
    this->setWindowTitle("Загрузка...");
    this->show();
    m_db = QSqlDatabase::addDatabase("QPSQL");
    connectDB(m_db);

    if (!m_db.open())        ui->statusbar->showMessage("Error: DB not connectred");
    else                     ui->statusbar->showMessage("DB connected succesfully");

    m_query = new QSqlQuery(m_db);
    tableView();
    this->setWindowTitle("Окно клиента");
    connect(ui->tableView, &QTableView::clicked, this, &ClientMainWindow::update_tableView);
    connect(ui->tableView_2, &QTableView::clicked, this, &ClientMainWindow::update_tableView2);
}

ClientMainWindow::~ClientMainWindow()
{
    delete ui;
}

void ClientMainWindow::setName(const std::string& newName)
{
    Name = newName;
}

void ClientMainWindow::tableView()
{
    QSqlQueryModel* result_model = new QSqlQueryModel(this);
    m_query->exec("SELECT film_id AS Number, title, duration, year FROM films;");
    result_model->setQuery(*m_query);
    ui->tableView->setModel(result_model);
}


void ClientMainWindow::tableView_2( int filmId)
{
    if (!m_db.open()){
        ui->statusbar->showMessage("Error: DB not connectred");
    }
    else{
        m_query->prepare("SELECT * FROM Sessions JOIN Films ON Sessions.film_id = Films.film_id WHERE Films.film_id = :filmId"); // Подготавливаем запрос для получения данных из базы
        m_query->bindValue(":filmId", filmId+1);

        if (!m_query->exec()) {
            qDebug() << "Error executing query: " << m_query->lastError().text();
            ui->label_2->setText("Произошла ошибка при выполнении запроса");
        } else {
            QSqlQueryModel* result_model = new QSqlQueryModel(this); // Создаем модель результата запроса
            result_model->setQuery(*m_query); // Устанавливаем результаты запроса в модель
            ui->tableView_2->setModel(result_model); // Устанавливаем модель второй таблицы
        }
    }
}

void ClientMainWindow::tableActors(int filmId)
{
    if (!m_db.open()){
        ui->statusbar->showMessage("Error: DB not connectred");
    }
    else{
        m_query->prepare("SELECT Actors.name FROM Actors JOIN ActorsFilms ON Actors.id = ActorsFilms.actor_id WHERE ActorsFilms.film_id = :filmId;"); // Подготавливаем запрос для получения данных из базы
        m_query->bindValue(":filmId", filmId+1);

        if (!m_query->exec()) {
            qDebug() << "Error executing query: " << m_query->lastError().text();
            ui->label_2->setText("Произошла ошибка при выполнении запроса");
        } else {
            QSqlQueryModel* result_model = new QSqlQueryModel(this); // Создаем модель результата запроса
            result_model->setQuery(*m_query); // Устанавливаем результаты запроса в модель
            ui->tableActors->setModel(result_model); // Устанавливаем модель второй таблицы
        }
    }
}

void ClientMainWindow::on_choice_clicked()
{

    QString filmId = ui->lineEdit->text();  // Получаем введенный film_id из поля ввода
    tableView_2(filmId.toInt());

}

void ClientMainWindow::on_pushButton_clicked()
{
    // Получаем значения из lineEdit
    QString row = ui->number_sess->text();
    QString seat = ui->my_row->text();
    QString customer = ui->my_seat->text();
    QString session_id = ui->my_name->text();

    // Подготавливаем запрос на вставку кортежа в таблицу Tickets
    m_query->prepare("INSERT INTO tickets(row, seat, customer, session_id) VALUES (:row, :seat, :customer, :session_id)");
    m_query->bindValue(":row", row);
    m_query->bindValue(":seat", seat);
    m_query->bindValue(":customer", session_id);
    m_query->bindValue(":session_id", customer );

    // Выполняем подготовленный запрос

    if (!m_query->exec() && !m_query->next()) {
        qDebug() << "Error executing query: " << m_query->lastError().text();
        ui->statusbar->showMessage("Произошла ошибка при выполнении запроса вставки");
    } else {
        ui->statusbar->showMessage("Кортеж успешно добавлен в таблицу Tickets");
    }
}

void ClientMainWindow::update_tableView(const QModelIndex &index)
{
    int number_row = index.row();

    qDebug() << number_row;
    qDebug() << ui->tableView->model()->index(number_row,1).data().toString();

    tableView_2(number_row);
    tableActors(number_row);

    ui->lineEdit->setText(QString::number(number_row+1));
}

void ClientMainWindow::update_tableView2(const QModelIndex &index){
    QVariant number_row = index.data();

    ui->number_sess->setText(QString::number(number_row.toInt()));
}

void ClientMainWindow::on_buttonSessionWindow_clicked()
{
   b = new basket();
   b->m_db = m_db;
   if (!m_db.open())        qDebug()<<"Error: DB not connectred";
   else                     qDebug()<<"DB connected succesfully";
}
